-- This file is part of the it-crafts software and is subject to copyright protection.
-- (C) 2022..2026, All rights reserved by Steffen Anders, Elsteraue - Germany
-- Visit also https://www.it-crafts.de.
--

IF 0 = (SELECT count(*) from [sysobjects] where ([xtype] = 'U' or [xtype] = 'V') and [name] = 'ut_Preiseinheiten')
BEGIN
CREATE TABLE [dbo].[ut_Preiseinheiten]
(
  [RecId]  integer NOT NULL
 ,[Nr] char(2) DEFAULT ''
 ,[Faktor] float DEFAULT 0
  CONSTRAINT [Pk_Preiseinheiten]  PRIMARY KEY NONCLUSTERED ( [RecId] )
)
END
GO

-- drop obsolete triggers and the triggered table with keyvalues
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_Preiseinheiten_KeyDel')
  DROP TRIGGER [dbo].[tr_Preiseinheiten_KeyDel]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_Preiseinheiten_KeyUpd')
  DROP TRIGGER [dbo].[tr_Preiseinheiten_KeyUpd]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'U' and [name] = 'ut_Preiseinheiten_Keys')
  DROP TABLE [dbo].[ut_Preiseinheiten_Keys]
GO

-- add new fields
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Preiseinheiten' and sc.[name] = 'Nr')
BEGIN
  ALTER TABLE [dbo].[ut_Preiseinheiten] ADD [Nr] char(2) NOT NULL DEFAULT ''
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Preiseinheiten' and sc.[name] = 'Faktor')
BEGIN
  ALTER TABLE [dbo].[ut_Preiseinheiten] ADD [Faktor] float NOT NULL DEFAULT 0
END
GO

-- check lengths of text fields
IF (2 > (select sc.length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Preiseinheiten' and sc.[name] = 'Nr'))
  AND (175 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Preiseinheiten' and sc.[name] = 'Nr'))
BEGIN
   ALTER TABLE [dbo].[ut_Preiseinheiten] ALTER COLUMN [Nr] char(2)
END
GO
IF (2 > (select length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Preiseinheiten' and sc.[name] = 'Nr'))
  AND (167 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_Preiseinheiten' and sc.[name] = 'Nr'))
BEGIN
   ALTER TABLE [dbo].[ut_Preiseinheiten] ALTER COLUMN [Nr] varchar(2)
END
GO

-- create dedicated view
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'V' and [name] = 'Preiseinheiten')
  DROP VIEW [dbo].[Preiseinheiten]
GO
CREATE VIEW [dbo].[Preiseinheiten] AS
  SELECT [RecId]
 ,[Nr]
 ,[Faktor]
  FROM [dbo].[ut_Preiseinheiten]
GO


-- create function to get the next RecId
IF OBJECT_ID (N'itcfunc_NextRecId_Preiseinheiten', N'FN') IS NOT NULL
  DROP FUNCTION dbo.itcfunc_NextRecId_Preiseinheiten
GO
CREATE FUNCTION dbo.itcfunc_NextRecId_Preiseinheiten() RETURNS integer
AS
BEGIN
  RETURN isnull((SELECT MAX(RecId) FROM [dbo].[ut_Preiseinheiten] WITH (READUNCOMMITTED)),0) + 1
END
GO

-- select with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel_Preiseinheiten')
  DROP PROCEDURE [dbo].[up_Sel_Preiseinheiten]
GO
CREATE PROCEDURE [dbo].[up_Sel_Preiseinheiten]  @mRI integer
AS
  SELECT
    [Nr]
   ,[Faktor]
  FROM [dbo].[ut_Preiseinheiten] WHERE RecId = @mRI
GO

-- select with modern clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel2_Preiseinheiten')
  DROP PROCEDURE [dbo].[up_Sel2_Preiseinheiten]
GO
CREATE PROCEDURE [dbo].[up_Sel2_Preiseinheiten]  @Param_RecId varchar(20)
AS
  DECLARE @mRI integer = dbo.itcfunc_integer(@Param_RecId)
  SELECT * FROM [dbo].[Preiseinheiten] WHERE RecId = @mRI
GO

-- insert with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Append_Preiseinheiten')
  DROP PROCEDURE [dbo].[up_Append_Preiseinheiten]
GO
CREATE PROCEDURE [dbo].[up_Append_Preiseinheiten]
   @Param_Nr char(2)
  ,@Param_Faktor float
AS
  DECLARE @NeueId integer
  DECLARE @m_CountDown integer = 10
  WHILE @m_CountDown > 0 BEGIN
    BEGIN TRANSACTION
    BEGIN TRY
      SET @NeueId = dbo.itcfunc_NextRecId_Preiseinheiten()
      INSERT INTO [dbo].[ut_Preiseinheiten] (RecId
        ,[Nr]
        ,[Faktor]
          ) VALUES (@NeueId
        ,UPPER(RTRIM(@Param_Nr))
        ,@Param_Faktor
          )
      COMMIT TRANSACTION
    END TRY
    BEGIN CATCH
      ROLLBACK TRANSACTION
      SET @NeueId = 0
    END CATCH

    IF @NeueId <> 0
      SET @m_CountDown = 0
    ELSE
      SET @m_CountDown = @m_CountDown - 1

    IF @m_CountDown > 0
      WAITFOR DELAY '00:00:00.050'
  END -- WHILE
  SELECT @NeueId AS RecId
GO

-- insert with obsolete clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Add_Preiseinheiten')
  DROP PROCEDURE [dbo].[up_Add_Preiseinheiten]
GO
CREATE PROCEDURE [dbo].[up_Add_Preiseinheiten]
AS
  DECLARE @NeueId integer = dbo.itcfunc_NextRecId_Preiseinheiten()
  INSERT INTO [dbo].[ut_Preiseinheiten] (RecId) VALUES( @NeueId )
  IF @@ERROR = 0
    SELECT @NeueId AS RecId
  ELSE
    SELECT 0 AS RecId
GO

-- update with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd_Preiseinheiten')
  DROP PROCEDURE [dbo].[up_Upd_Preiseinheiten]
GO
CREATE PROCEDURE [dbo].[up_Upd_Preiseinheiten] @mRI integer
  ,@Param_Nr char(2)
  ,@Param_Faktor float
AS
  UPDATE [dbo].[ut_Preiseinheiten] SET
    [Nr] = UPPER(RTRIM(@Param_Nr))
   ,[Faktor] = @Param_Faktor
  WHERE RecId = @mRI
GO

-- update with modern clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd2_Preiseinheiten')
  DROP PROCEDURE [dbo].[up_Upd2_Preiseinheiten]
GO
CREATE PROCEDURE [dbo].[up_Upd2_Preiseinheiten] @Param_RecId varchar(20)
  ,@Param_Nr varchar(2)
  ,@Param_Faktor varchar(10)
AS
  DECLARE @mRI integer = dbo.itcfunc_integer(@Param_RecId)
  UPDATE [dbo].[ut_Preiseinheiten] SET
    [Nr] = UPPER(RTRIM(@Param_Nr))
   ,[Faktor] = dbo.itcfunc_float(@Param_Faktor)
  WHERE RecId = @mRI

  EXECUTE [dbo].[up_Sel2_Preiseinheiten] @mRI
GO

-- delete
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Del_Preiseinheiten')
  DROP PROCEDURE [dbo].[up_Del_Preiseinheiten]
GO
CREATE PROCEDURE [dbo].[up_Del_Preiseinheiten] @mRI integer
AS
  DELETE FROM [dbo].[ut_Preiseinheiten] WHERE RecId = @mRI
GO

-- text index
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_TrSel_Preiseinheiten')
  DROP PROCEDURE [dbo].[up_TrSel_Preiseinheiten]
GO
CREATE PROCEDURE [dbo].[up_TrSel_Preiseinheiten]
AS
  SELECT RecId,
    LTRIM(RTRIM([Nr]))
  AS Data FROM [dbo].[ut_Preiseinheiten] WHERE RecId > 0 ORDER BY RecId
GO

-- reindex
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Reorg_Preiseinheiten')
  DROP PROCEDURE [dbo].[up_Reorg_Preiseinheiten]
GO
CREATE PROCEDURE [dbo].[up_Reorg_Preiseinheiten] @bDbcc integer,@bRecId integer
AS
  IF (@bRecId = 1)
  BEGIN
    DECLARE  C        CURSOR FOR SELECT RecId FROM [dbo].[ut_Preiseinheiten] ORDER BY RecId
    DECLARE  @CurrId  integer
    DECLARE  @NextId  integer
    --BEGIN TRANSACTION
    OPEN C
    SET @NextId = 1
    FETCH NEXT FROM C INTO @CurrId
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
      IF @CurrId <> @NextId
      UPDATE [dbo].[ut_Preiseinheiten] SET RecId=@NextId WHERE CURRENT OF C
      SET @NextId = @NextId + 1
      FETCH NEXT FROM C INTO @CurrId
    END
    CLOSE C
    --COMMIT TRANSACTION
    DEALLOCATE C
  END

  IF (@bDbcc = 1)
  BEGIN
    DBCC DBREINDEX ( [ut_Preiseinheiten] )
  END
GO

-- logical key  ORDER BY Nr,RecId
IF 0 < (select count(*) from sysindexes si inner join sysobjects so on so.[xtype] = 'U' and so.[name] = 'ut_Preiseinheiten' and so.[id] = si.[id] and si.[name] = 'Ik_Primary')
  DROP INDEX [Ik_Primary] ON [dbo].[ut_Preiseinheiten]
GO
IF 0 = (select count(*) from sysindexes si inner join sysobjects so on so.[xtype] = 'U' and so.[name] = 'ut_Preiseinheiten' and so.[id] = si.[id] and si.[name] = 'Ik_Primary')
  CREATE INDEX [Ik_Primary] ON [dbo].[ut_Preiseinheiten] (Nr,RecId)
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_First_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[up_First_Preiseinheiten_Primary]
GO
CREATE PROCEDURE [dbo].[up_First_Preiseinheiten_Primary] AS
  SELECT TOP 1 RecId FROM [dbo].[ut_Preiseinheiten] WITH(INDEX = Ik_Primary) ORDER BY Nr,RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_First_Preiseinheiten_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_First_Preiseinheiten_Primary] AS EXECUTE [dbo].[up_First_Preiseinheiten_Primary]')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Last_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[up_Last_Preiseinheiten_Primary]
GO
CREATE PROCEDURE [dbo].[up_Last_Preiseinheiten_Primary] AS
  SELECT TOP 1 RecId FROM [dbo].[ut_Preiseinheiten] WITH(INDEX = Ik_Primary) ORDER BY Nr desc,RecId desc
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Last_Preiseinheiten_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_Last_Preiseinheiten_Primary] AS EXECUTE [dbo].[up_Last_Preiseinheiten_Primary]')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[up_Next_Preiseinheiten_Primary]
GO
CREATE PROCEDURE [dbo].[up_Next_Preiseinheiten_Primary] @oldRecId integer AS
  DECLARE @oldNr char(2)
  SELECT @oldNr = Nr FROM [dbo].[ut_Preiseinheiten] WHERE RecId = @oldRecId

  DECLARE @newRecId integer

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Preiseinheiten] WITH(INDEX = Ik_Primary)
    WHERE (Nr > @oldNr)
    ORDER BY Nr,RecId
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Next_Preiseinheiten_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_Next_Preiseinheiten_Primary] @oldRecId integer AS EXECUTE [dbo].[up_Next_Preiseinheiten_Primary] @oldRecId')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[up_Prior_Preiseinheiten_Primary]
GO
CREATE PROCEDURE [dbo].[up_Prior_Preiseinheiten_Primary] @oldRecId integer AS
  DECLARE @oldNr char(2)
  SELECT @oldNr = Nr FROM [dbo].[ut_Preiseinheiten] WHERE RecId = @oldRecId

  DECLARE @newRecId integer

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_Preiseinheiten] WITH(INDEX = Ik_Primary)
    WHERE (Nr < @oldNr)
    ORDER BY Nr desc,RecId desc
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Prior_Preiseinheiten_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_Prior_Preiseinheiten_Primary] @oldRecId integer AS EXECUTE [dbo].[up_Prior_Preiseinheiten_Primary] @oldRecId')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next50_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[up_Next50_Preiseinheiten_Primary]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Next50_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[qp_Next50_Preiseinheiten_Primary]
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior50_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[up_Prior50_Preiseinheiten_Primary]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Prior50_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[qp_Prior50_Preiseinheiten_Primary]
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindF_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[up_FindF_Preiseinheiten_Primary]
GO
CREATE PROCEDURE [dbo].[up_FindF_Preiseinheiten_Primary] @xKey char(250), @xLen integer AS
  DECLARE @mNr char(2) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,1,2)

  -- pass 1 -- Abfrage mit vollständigen Feldern (absteigende Vergleichslänge)

  IF @xLen = 2 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Preiseinheiten] WITH(INDEX = Ik_Primary) WHERE 
      Nr = @mNr
      ORDER BY Nr,RecId
    RETURN
  END

  -- pass 2 -- Abfrage mit teilweise unkompletten Felder (aufsteigende Vergleichslänge)

  IF @xLen < 2 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Preiseinheiten] WITH(INDEX = Ik_Primary) WHERE 
      Nr >= @mNr AND SUBSTRING(Nr,1,LEN(@mNr)) = @mNr
      ORDER BY Nr,RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_FindF_Preiseinheiten_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_FindF_Preiseinheiten_Primary] @xKey char(250), @xLen integer AS EXECUTE [dbo].[up_FindF_Preiseinheiten_Primary] @xKey, @xLen')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindL_Preiseinheiten_Primary')
  DROP PROCEDURE [dbo].[up_FindL_Preiseinheiten_Primary]
GO
CREATE PROCEDURE [dbo].[up_FindL_Preiseinheiten_Primary] @xKey char(250), @xLen integer AS
  DECLARE @mNr char(2) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,1,2)

  -- pass 1 -- Abfrage mit vollständigen Feldern (absteigende Vergleichslänge)

  IF @xLen = 2 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Preiseinheiten] WITH(INDEX = Ik_Primary) WHERE 
      Nr = @mNr
      ORDER BY Nr desc,RecId desc
    RETURN
  END

  -- pass 2 -- Abfrage mit teilweise unkompletten Felder (aufsteigende Vergleichslänge)

  IF @xLen < 2 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_Preiseinheiten] WITH(INDEX = Ik_Primary) WHERE 
      SUBSTRING(Nr,1,LEN(@mNr)) = @mNr
      ORDER BY Nr desc,RecId desc
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_FindL_Preiseinheiten_Primary')
  EXEC('ALTER PROCEDURE [dbo].[qp_FindL_Preiseinheiten_Primary] @xKey char(250), @xLen integer AS EXECUTE [dbo].[up_FindL_Preiseinheiten_Primary] @xKey, @xLen')
GO


